<html>

<head>
    <meta charset="UTF-8">
    <link rel="stylesheet" href="css/styles.css">
    <link rel="stylesheet" href="css/htmldiff.css">
</head>

<body>
    <a href="index.html">👈 Back</a>
    <h1>Regex Tool</h1>
    <div>
        <label>Regex:</label><br>
        <textarea id="regexInput" cols="100" rows="1">^https:\\/\\/([A-Za-z0-9]+\\.)?some-site\\.ch(\\?.*|;.*|\\#.*|\\/|\\/some-path|\\/\\?.*|\\/;.*|\\/\\#.*)?$</textarea>
    </div>
    <div>
        <label>Test strings:</label><br>
        <textarea id="testStringsInput" cols="100" rows="5">
https://www.some-site.ch
https://ww11112223.some-site.ch
https://www.some-site.ch/some-path
https://some-site.ch
https://www.some-site.cz
        </textarea>
    </div>
    <br><button id="testButton">Test</button>
    <div id="console"></div>
    <div id="output"></div>
    <script>
        window.onload = function () {
            document.getElementById("testButton").addEventListener("click", function () {
                consoleDivLog("")
                populateAllData("output")
            });
        }

        function consoleDivLog(string) {
            document.getElementById("console").innerHTML = string
        }

        function escapeRegExp(stringToGoIntoTheRegex) {
            return stringToGoIntoTheRegex.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&');
        }

        function populateAllData(id) {
            // const regexString = escapeRegExp(document.getElementById("regexInput").value)
            const regexString = document.getElementById("regexInput").value.replaceAll('\\\\', '\\')
            const testStrings = document.getElementById("testStringsInput").value.split("\n").filter(e => typeof e === 'string' && e.trim() !== '')
            if (regexString.length == 0) {
                consoleDivLog(`Warning: "regexInput" is empty`)
                return
            }
            if (testStrings.length == 0) {
                consoleDivLog(`Warning: "testStringsInput" is empty`)
                return
            }
            consoleDivLog(`unescaped regex string = ${regexString}`)

            var output = ""
            testStrings.forEach(element => {
                const re = new RegExp(regexString, 'g');
                // console.log(re)
                if (re.test(element)) {
                    output += `<br><ins>${element}</ins>`
                } else {
                    output += `<br><del>${element}</del>`
                }
                // wtf? regexes get spent?
                // console.log(`regex ${re} - string: ${element} --- match: ${re.test(element)}`)
                // console.log(`regex ${re} - string: ${element} --- match: ${re.test(element)}`)
            });

            document.getElementById(id).innerHTML = `<h2>Output</h2>${output}`
        }
    </script>
</body>

</html>